////// Fragment Shader
precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D toneCurveTexture;
uniform float skipTone;

void main() {
    if (skipTone < 0.005) {
        vec4 textureColor = texture2D(inputImageTexture, textureCoordinate);
        float redCompositeCurveValue = clamp(texture2D(toneCurveTexture, vec2(textureColor.r, 0.0)).r, 0.0, textureColor.a);
        float greenCompositeCurveValue = clamp(texture2D(toneCurveTexture, vec2(textureColor.g, 0.0)).g, 0.0, textureColor.a);
        float blueCompositeCurveValue = clamp(texture2D(toneCurveTexture, vec2(textureColor.b, 0.0)).b, 0.0, textureColor.a);
        float redCurveValue = texture2D(toneCurveTexture, vec2(redCompositeCurveValue, 1.0)).r;
        float greenCurveValue = texture2D(toneCurveTexture, vec2(greenCompositeCurveValue, 1.0)).g;
        float blueCurveValue = texture2D(toneCurveTexture, vec2(blueCompositeCurveValue, 1.0)).b;

        gl_FragColor = vec4(redCurveValue, greenCurveValue, blueCurveValue, textureColor.a);
    } else {
        gl_FragColor = texture2D(inputImageTexture, textureCoordinate);
    }
}